%define maj 1
%define min 5
%define rel 2
%define short_name j3d

%define target_cpu i586
%define short_cpu x86
%define aka_cpu i386

%define my_requires /tmp/my-requires
%define _binary_dist 0

%define name java3d
%define version %{maj}.%{min}.%{rel}
%define release %mkrel 1

Name:			%{name}
Version:		%{version}
Release:		%{release}
Summary:		Java 3D API
URL:			https://java3d.dev.java.net/
License:		GPL
Group:			Development/Java
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if "%{_binary_dist}" == "1"
Source0:		http://download.java.net/media/java3d/builds/release/%{version}/j3d-%{maj}_%{min}_%{rel}-linux-i586.zip
Source1:		http://download.java.net/media/java3d/builds/release/%{version}/j3d-%{maj}_%{min}_%{rel}-linux-amd64.zip
Source2:		http://download.java.net/media/java3d/builds/release/%{version}/j3d-%{maj}_%{min}_%{rel}-api-docs.zip
%else
Source0:		vecmath-%{version}.tar.bz2
Source1:		j3d-core-%{version}.tar.bz2
Source2:		j3d-core-utils-%{version}.tar.bz2
%endif

%if "%{_binary_dist}" == "0"
BuildRequires:	j2sdk-ant
BuildRequires:	java-1.6.0-sun-devel
BuildRequires:	gcc-c++
BuildRequires:	mesa-common-devel
BuildRequires:	update-alternatives
BuildRequires:	libxerces-c0-devel
%endif
BuildRequires:	jpackage-utils
BuildRequires:	unzip
Requires:		java-1.6.0-sun

%description
The Java 3D API provides a set of object-oriented interfaces that
support a simple, high-level programming model you can use to
build, render, and control the behavior of 3D objects and visual
environments. With the Java 3D API, you can incorporate high quality,
scalable, platform-independent 3D graphics into applications andvecmath
applets based on Java technology.

%package javadoc
Summary:	Javadoc for java3d
Group:		Documentation/HTML
PreReq:		coreutils

%description javadoc
Javadoc for java3d.

%if "%{_binary_dist}" == "0"
%debug_package
%endif

%prep
%setup -q -T -c -n %{name}
%if "%{_binary_dist}" == "1"
		%__unzip -q -o %{SOURCE0}

	pushd %{short_name}-%{maj}_%{min}_%{rel}-linux-%{target_cpu}
		%__unzip -q -o %{short_name}-jre.zip
	
		# javadoc
		%__unzip -q %{SOURCE2}
	popd
%else
	tar xf %{SOURCE0}
	tar xf %{SOURCE1}
	tar xf %{SOURCE2}
%endif

%build
%if "%{_binary_dist}" == "0"
pushd vecmath
	ant jar-opt
popd

pushd j3d-core
	# to avoid Out of heap memory on "small" machines ...
	export ANT_OPTS=-Xmx256m
	ant \
		-Dbuild.type=stable \
		jar-opt docs-public
popd
%endif

%install
%__install -dm 755 %{buildroot}%{_javadir}/%{name}
%__install -dm 755 %{buildroot}%{_libdir}
%__install -dm 755 %{buildroot}%{_javadocdir}/%{name}-%{version}

%if "%{_binary_dist}" == "1"
	pushd %{short_name}-%{maj}_%{min}_%{rel}-linux-%{target_cpu}
		# jars
		%__install -m 644 lib/ext/*.jar \
			%{buildroot}%{_javadir}/%{name}
		
		# libs
		%__install -m 644 lib/%{aka_cpu}/*.so \
			%{buildroot}%{_libdir}
		
		# javadoc
		%__cp -a %{short_name}-%{maj}_%{min}_%{rel}-api-docs/* \
			%{buildroot}%{_javadocdir}/%{name}-%{version}
	popd
%else
	# jars
	%__install -m 644 vecmath/build/opt/lib/ext/vecmath.jar \
		%{buildroot}%{_javadir}/%{name}
	%__install -m 644 j3d-core/build/default/opt/lib/ext/*.jar \
		%{buildroot}%{_javadir}/%{name}

	# libs
	%__install -m 644 j3d-core/build/default/opt/native/*.so \
		%{buildroot}%{_libdir}

	# javadoc
	%__cp -a j3d-core/build/*/javadocs/docs-public/* \
		%{buildroot}%{_javadocdir}/%{name}-%{version}
%endif

ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name} # ghost symlink

# exclude libjawt.so from the requires-list (it is NOT provided by java ...)
%__cat << EOF > %{my_requires}
%{__find_requires} | grep -v "libjawt.so"
EOF
%__chmod 755 %{my_requires}
%define __find_requires %{my_requires}

%clean
[ -d %{buildroot} -a "%{buildroot}" != "" ] && %__rm -rf %{buildroot}
%__rm -f %{my_requires}

%post javadoc
%__rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%if "%{_binary_dist}" == "1"
%doc %{short_name}-%{maj}_%{min}_%{rel}-linux-%{target_cpu}/*.txt
%doc %{short_name}-%{maj}_%{min}_%{rel}-linux-%{target_cpu}/*.html
%else
%doc j3d-core/*.txt
%doc j3d-core/*.html
%doc j3d-core/docs
%endif

%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_libdir}/lib*.so

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Sat Jun 14 2009 MBantz <martin dot bantz at gmail dot com> 1.5.2-0.pm.1-1pclos2007
- Built for PCLinux from Toni Graffy toni at links2linux.de
